﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using DotSpatial.Controls;
using DotSpatial.Data;
//using DotSpatial.Topology;
using DotSpatial.Symbology;

namespace DotSpatialHelloWorld
{
    public partial class frmIdentify : Form
    {
        private IFeatureLayer layer;
        private List<IFeature> features;
        public frmIdentify()
        {
            InitializeComponent();
        }

        private void frmIdentify_Load(object sender, EventArgs e)
        {

        }

        private void ShowAttributes(int ord) {
            IFeature f = features[ord];
            if (f == null) return;
            DataTable dt = new DataTable();
            dt.Columns.Add("Field Name");
            dt.Columns.Add("Value");

            if (f.DataRow == null)
            {
                f.ParentFeatureSet.FillAttributes();
            }
            DataColumn[] columns = f.ParentFeatureSet.GetColumns();
            foreach (DataColumn fld in columns)
            {
                DataRow dr = dt.NewRow();
                dr["Field Name"] = fld.ColumnName;
                if (f.DataRow != null) dr["Value"] = f.DataRow[fld.ColumnName].ToString();
                dt.Rows.Add(dr);
            }
            dgAttributes.DataSource = dt;
        }

        public void Add(IFeatureLayer layer, Extent bounds)
        {
            this.layer = layer;
            features = layer.DataSet.Select(bounds);
            foreach (IFeature feature in features)
            {
                cmbFid.Items.Add(feature.Fid);              
            }
            cmbFid.SelectedItem = 0;
        }

        private void cmbFid_SelectedIndexChanged(object sender, EventArgs e)
        {
            ShowAttributes(cmbFid.SelectedIndex);
        }
    }
}
