﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using DotSpatial.Controls;
using DotSpatial.Data;
using DotSpatial.Topology;
using DotSpatial.Symbology;

namespace DotSpatialHelloWorld
{
    public partial class frmMap : Form
    {
        public frmMap()
        {
            InitializeComponent();
        }

        private void frmMap_Load(object sender, EventArgs e)
        {
            initialize();
        }

        private void initialize() {
            legendMain.AddMapFrame(mapMain.MapFrame);
            mapMain.FunctionMode = FunctionMode.Pan;
        }

        private void addLayer()
        {
            mapMain.AddLayer();
        }

        private void zoomToMaxExtent()
        {
            mapMain.ZoomToMaxExtent();
            //mapMain.ViewExtents = new DotSpatial.Data.Extent(16, 50, 17, 51);
            //map1.Refresh();
        }

        private void showZoom()
        {
            frmZoomToExtent f = new frmZoomToExtent();
            f.mapX = mapMain;
            f.Show();
            //f.ShowDialog(this);
        }

        private void showTable()
        {
            frmTable ft = new frmTable();
            IMapFeatureLayer layer = (IMapFeatureLayer) mapMain.Layers[0];
            ft.dataGridView1.DataSource = layer.DataSet.DataTable;
            ft.map1 = mapMain;
            ft.Show();
        }

        private void mapMain_Load(object sender, EventArgs e)
        {

        }

        private void mapMain_DoubleClick(object sender, EventArgs e)
        {
            addLayer();
        }

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            addLayer();
        }

        private void tsbZoomForm_Click(object sender, EventArgs e)
        {
            showZoom();
        }

        private void tsbTable_Click(object sender, EventArgs e)
        {
            showTable();
        }

        private void tsbIdentify_Click(object sender, EventArgs e)
        {
            //mapMain.FunctionMode = FunctionMode.Info;
            mapMain.FunctionMode = FunctionMode.None;
        }

        private void tsbPan_Click(object sender, EventArgs e)
        {
            mapMain.FunctionMode = FunctionMode.Pan;
        }

        private void tsbFullExtent_Click(object sender, EventArgs e)
        {
            zoomToMaxExtent();
        }

        private void mapMain_Click(object sender, EventArgs e)
        {
            if (mapMain.FunctionMode == FunctionMode.None)
            {
                frmIdentify fi = new frmIdentify();
                GeoMouseArgs args = new GeoMouseArgs((MouseEventArgs) e, mapMain);
                Envelope env = new Envelope(args.GeographicLocation);
                env.ExpandBy(mapMain.Extent.Width / 10);
                fi.Add((IFeatureLayer) mapMain.Layers[0], env.ToExtent());
                fi.Show();
            }
        }
    }
}
